﻿using Senparc.CO2NET;
using Senparc.CO2NET.Cache;
using Senparc.CO2NET.RegisterServices;
using Senparc.Weixin;
using Senparc.Weixin.Cache.Redis;
using Senparc.Weixin.Entities;
using Senparc.Weixin.MP;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Optimization;
using System.Web.Routing;

namespace WebApplication2
{
    public class MvcApplication : System.Web.HttpApplication
    {
        protected void Application_Start()
        {
            AreaRegistration.RegisterAllAreas();
            FilterConfig.RegisterGlobalFilters(GlobalFilters.Filters);
            RouteConfig.RegisterRoutes(RouteTable.Routes);
            BundleConfig.RegisterBundles(BundleTable.Bundles);


            var redisConnectionString = "localhost:6379";
            //全局配置
            //全局设置参数，将被储存到 Senparc.CO2NET.Config.SenparcSetting
            Senparc.CO2NET.Cache.Redis.Register.SetConfigurationOption(redisConnectionString);
            Senparc.CO2NET.Cache.Redis.Register.UseKeyValueRedisNow();//键值对缓存策略（推荐）


            var senparcSetting = SenparcSetting.BuildFromWebConfig(false);
            var register = RegisterService.Start(senparcSetting)
                                          .UseSenparcGlobal(false, () => {
                                              var exContainerCacheStrategies = new List<IDomainExtensionCacheStrategy>();
                                              senparcSetting = senparcSetting ?? new SenparcSetting();
                                              exContainerCacheStrategies.Add(RedisContainerCacheStrategy.Instance);
                                              return exContainerCacheStrategies;
                                          })
                                          .RegisterThreads()//启动线程，RegisterThreads()也可以省略，在Start()中已经自动注册
                                          .ChangeDefaultCacheNamespace(senparcSetting.DefaultCacheNamespace);// 当同一个分布式缓存同时服务于多个网站（应用程序池）时，可以使用命名空间将其隔离（非必须）

            

            //微信配置
            var senparcWeixinSetting = SenparcWeixinSetting.BuildFromWebConfig(false);
            register.UseSenparcWeixin(senparcWeixinSetting, senparcSetting)
                    .RegisterMpAccount(senparcWeixinSetting.WeixinAppId, senparcWeixinSetting.WeixinAppSecret, "测试");
        }
    }
}
